/* drawervisitor -- Base class for classes that operate on the Drawer hierarchy
   Copyright (C) 2002 Aaron Bentley

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

using meta::Typelist;

typedef meta::List<DarkFirst, PrettyDrawer, Drawer>::Ret Drawertypelist;
namespace visitor
{
   ///A virtual visitor that visits every Drawer subclass
   typedef TlVisitor<Drawertypelist>::Ret DrawerVisitor;
}


class DrawerName: public visitor::DrawerVisitor
{
   private:
   void do_visit(DarkFirst &source)
   {
      context::ContException foo("DarkFirst");
      throw foo;
   }
   void do_visit(PrettyDrawer &source)
   {
      context::ContException foo("PrettyDrawer");
      throw foo;
   }
   void do_visit(Drawer &source)
   {
      context::ContException foo("Drawer");
      throw foo;
   }

};


