/* Exception base class for throwing exceptions
   Copyright (C) 2002 Aaron Bentley

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
#ifndef _EXCEPTION_H_
#define _EXCEPTION_H_ //make idempotent
#include <iostream>

/**
 * \brief An exception class that can be written to stdout
 */
class Exception
{
public:
   /**
    * \brief Writes a message to an ostream.
    * \param out The ostream to write to
    */
   virtual void write(std::ostream &out) const
   {
      out<<"An exception ocurred." << std::endl;
   }
};

std::ostream &operator<<(std::ostream &output, Exception &err);
#endif //_EXCEPTION_H_
