/* rotatedrawer -- rotates the type of object doing drawing
   Copyright (C) 2002 Aaron Bentley

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
class RotateDrawer: public visitor::DrawerVisitor
{
private:
   TreeView &tv;
   void do_visit(DarkFirst &source)
   {
      tv.setDrawer(new Drawer(tv.get_window()));
   }
   void do_visit(PrettyDrawer &source)
   {
      tv.setDrawer(new DarkFirst(tv.get_window())); 
   }
   void do_visit(Drawer &source)
   {
      tv.setDrawer(new PrettyDrawer(tv.get_window()));
   }

   public:
   RotateDrawer(TreeView &atv)
      :
   tv(atv)
   {}
};

